"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.delete = exports.put = exports.post = exports.get = void 0;
const WIXAPIS_VELO_BASE_PATH = 'https://www.wixapis.com/velo/v1/http/invoke';
function get(httpClient) {
    const fetch = fetchFactory(httpClient);
    return function (functionName, options) {
        return fetch('GET', functionName, options);
    };
}
exports.get = get;
function post(httpClient) {
    const fetch = fetchFactory(httpClient);
    return function (functionName, options) {
        return fetch('POST', functionName, options);
    };
}
exports.post = post;
function put(httpClient) {
    const fetch = fetchFactory(httpClient);
    return function (functionName, options) {
        return fetch('PUT', functionName, options);
    };
}
exports.put = put;
// export function patch(httpClient: HttpClient) {
//   const fetch = fetchFactory(httpClient);
//   return function (functionName: string, options?: InvokeOptionsWithBody) {
//     return fetch('PATCH', functionName, options);
//   };
// }
function _delete(httpClient) {
    const fetch = fetchFactory(httpClient);
    return function (functionName, options) {
        return fetch('DELETE', functionName, options);
    };
}
exports.delete = _delete;
function fetchFactory(httpClient) {
    return function (method, functionName, options) {
        const url = buildUrl(functionName, options?.params);
        return httpClient.fetchWithAuth(url, {
            method,
            body: options?.body,
            headers: options?.headers,
        });
    };
}
function buildUrl(functionName, params) {
    const url = new URL(`${WIXAPIS_VELO_BASE_PATH}/${encodeURIComponent(functionName)}`);
    url.search = params?.toString() ?? '';
    return url.toString();
}
//# sourceMappingURL=functions.js.map