const WIXAPIS_VELO_BASE_PATH = 'https://www.wixapis.com/velo/v1/http/invoke';
export function get(httpClient) {
    const fetch = fetchFactory(httpClient);
    return function (functionName, options) {
        return fetch('GET', functionName, options);
    };
}
export function post(httpClient) {
    const fetch = fetchFactory(httpClient);
    return function (functionName, options) {
        return fetch('POST', functionName, options);
    };
}
export function put(httpClient) {
    const fetch = fetchFactory(httpClient);
    return function (functionName, options) {
        return fetch('PUT', functionName, options);
    };
}
// export function patch(httpClient: HttpClient) {
//   const fetch = fetchFactory(httpClient);
//   return function (functionName: string, options?: InvokeOptionsWithBody) {
//     return fetch('PATCH', functionName, options);
//   };
// }
function _delete(httpClient) {
    const fetch = fetchFactory(httpClient);
    return function (functionName, options) {
        return fetch('DELETE', functionName, options);
    };
}
// export function head(httpClient: HttpClient) {
//   const fetch = fetchFactory(httpClient);
//   return function (functionName: string, options?: InvokeOptions) {
//     return fetch('HEAD', functionName, options);
//   };
// }
// export function connect(httpClient: HttpClient) {
//   const fetch = fetchFactory(httpClient);
//   return function (functionName: string, options?: InvokeOptions) {
//     return fetch('CONNECT', functionName, options);
//   };
// }
// export function options(httpClient: HttpClient) {
//   const fetch = fetchFactory(httpClient);
//   return function (functionName: string, options?: InvokeOptions) {
//     return fetch('OPTIONS', functionName, options);
//   };
// }
// export function trace(httpClient: HttpClient) {
//   const fetch = fetchFactory(httpClient);
//   return function (functionName: string, options?: InvokeOptions) {
//     return fetch('TRACE', functionName, options);
//   };
// }
export { _delete as delete };
function fetchFactory(httpClient) {
    return function (method, functionName, options) {
        const url = buildUrl(functionName, options?.params);
        return httpClient.fetchWithAuth(url, {
            method,
            body: options?.body,
            headers: options?.headers,
        });
    };
}
function buildUrl(functionName, params) {
    const url = new URL(`${WIXAPIS_VELO_BASE_PATH}/${encodeURIComponent(functionName)}`);
    url.search = params?.toString() ?? '';
    return url.toString();
}
//# sourceMappingURL=functions.js.map